/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.ExternalSessionDialog"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojox.data.dom"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.internal.Dialog"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.repository.web.ui.internal", "ExternalTeamServerClientMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal", "ExternalTeamServerClientMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.repository.web.ui.internal.ExternalSessionDialog",  //$NON-NLS-1$
			 [dijit._Widget, dijit._Templated], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_dialogRoot: null,

	_message: null,
	_continueButton: null,
	_loginButton: null,
	_cancelButton: null,
	_remember: null,

	_serverDescription: null,
	_contributor: null,
	_requestLabel: null,
	
	_labelDoNotAskAgain: MSGS.SESSIONDIALOG_DONOTASKAGAIN,
	_labelContinue: MSGS.SESSIONDIALOG_BUTTON_CONTINUE,
	_labelLogin: MSGS.SESSIONDIALOG_BUTTON_LOGIN,
	_labelCancel: MSGS.SESSIONDIALOG_BUTTON_CANCEL,
	
	constructor: function() {
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	// ---- events ---------------------------------------------------------------------------------------------------------	

	onContinue: function(doNotAskAgain) {
	},

	onChangeLogin: function(doNotAskAgain) {
	},

	onCancel: function(doNotAskAgain) {
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/templates/ExternalSessionDialog.html"), //$NON-NLS-1$ //$NON-NLS-2$

	postCreate: function() {

		this._dialog = new net.jazz.ajax.ui.internal.Dialog({
			contentNode: this._dialogRoot,
			primaryTitle: MSGS.SESSIONDIALOG_TITLE,
			width: "30em", //$NON-NLS-1$
			isClosable: false
		});

		dojox.data.dom.replaceChildren(this._messageServer, document.createTextNode(bind(MSGS.SESSIONDIALOG_SERVER, [ 
			this._serverDescription.getName(), 
			this._serverDescription.getUrl() ])));

		dojox.data.dom.replaceChildren(this._messageOperation, document.createTextNode(bind(MSGS.SESSIONDIALOG_OPERATION, [ 
			this._requestLabel,
			this._contributor.name,
			this._contributor.emailAddress ])));

		this.connect(this._continueButton, "onclick", "_doContinue"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this._loginButton, "onclick", "_doChangeLogin"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this._cancelButton, "onclick", "_doCancel"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_doContinue: function() {
		try {
			this.onContinue(this._remember.value);
		} finally {
			this._dialog.close();
		}
	},

	_doChangeLogin: function() {
		try {
			this.onChangeLogin(this._remember.value);
		} finally {
			this._dialog.close();
		}
	},

	_doCancel: function() {
		try {
			this.onCancel(this._remember.value);
		} finally {
			this._dialog.close();
		}
	},

	__sentinel: null // terminates this class definition
});

com.ibm.team.repository.web.ui.internal.ExternalSessionDialog.create= function(serverDescription, contributor, requestLabel) {
	return new com.ibm.team.repository.web.ui.internal.ExternalSessionDialog({
		_serverDescription: serverDescription,
		_contributor: contributor,
		_requestLabel: requestLabel
	}, null);
};

})();
