/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.ServerPropertyShortElement");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "ServerPropertyMessages");


(function() {

var checkNotNull = net.jazz.ajax.toolbox.lang.checkNotNull;
var ERR_IMG_SRC = dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/images/inline-error.gif");
var WARN_IMG_SRC = dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/images/inline-warning.gif");
var ServerPropertyElement = com.ibm.team.repository.web.ui.internal.admin.server.ServerPropertyElement;

dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.ServerPropertyShortElement", [ServerPropertyElement, dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/server/templates/ServerPropertyShortElement.html"),
	
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "ServerPropertyMessages");
	},
	
	postCreate: function() {
		com.ibm.team.repository.web.ui.internal.admin.server.ServerPropertyShortElement.superclass.postCreate.apply(this);
		checkNotNull(this.elementInfo, "this.elementInfo");
		checkNotNull(this.displayIn, "this.displayIn");
		
		this.domNode._defaultSortVal = this.elementInfo.displayName;
		if (this.customSortValue != null) {
			this.domNode._customSortVal = this.customSortValue;
		}
		this._activeFilters = new Object();
		this._name = this.elementInfo.name;
		this.domNode._propertyName = this._name;
		this._displayName = this.elementInfo.displayName;
		this._currentValue = this.elementInfo.overrideValue != null ? this.elementInfo.overrideValue :
							this.elementInfo.defaultValue != null ? this.elementInfo.defaultValue : "";
		this._savedValue = this._currentValue;
		this._restartRequired = this.elementInfo.updatePolicy == "FRAMEWORK_RESTART";
		this._defaultValue = this.elementInfo.defaultValue;
		if (this._currentValue == this._defaultValue) {
			dojo.toggleClass(this._propertyDefault, "fadedText", true);
		}
		else {
			dojo.toggleClass(this._propertyDefault, "fadedText", false);
		}
		this._description = this.elementInfo.description;
		if (this._prefix == null) {
			this._prefix = "";
		}
		this._propertyName.id = this._prefix + this._name + ".propertyName";
		if (this._descriptionMode == "tooltip") {
			if (dojo.isIE) {
				dojo.toggleClass(this._propertyName, "TooltipCursor", true);
				this.connect(this._propertyName,"onmouseover", function () {
					dojo.toggleClass(this._propertyName, "TooltipColor", true);
				});
				this.connect(this._propertyName,"onmouseout", function () {
					dojo.toggleClass(this._propertyName, "TooltipColor", false);
				});
			}
			else {
				dojo.toggleClass(this._propertyName, "Tooltip", true);
			}
		}
		this._propertyName.appendChild(document.createTextNode(this._displayName));
		this._errIcon = document.createElement("img");
		this._errIcon.className = "errIcon";
		this._errIcon.src = ERR_IMG_SRC;
		this._errIcon.style.visibility = "hidden";
		this._propertyValue.appendChild(this._errIcon);
		this._warnIcon = document.createElement("img");
		this._warnIcon.className = "errIcon";
		this._warnIcon.src = WARN_IMG_SRC;
		this._warnIcon.style.display = "none";
		this._propertyValue.appendChild(this._warnIcon);
		this._editValueNode = this._createInputNode();
		this._propertyValue.appendChild(this._editValueNode);
		this._viewValueNode = document.createElement("span");
		this._viewValueNode.className = "viewValueNode";
		this._viewValueNode.appendChild(this._createDisplayNode(this._currentValue));
		this._propertyValue.appendChild(this._viewValueNode);
		this._invalidValueMsg = document.createElement("div");
		this._invalidValueMsg.className = "invalidMsg";
		this._propertyValue.appendChild(this._invalidValueMsg);
		this._cssHash = new Object();
		this._cssPriority = [ "invalidValue", "changePending", "successfulChange", "restartRequired" ];
		this.connect(this._editValueNode, "onchange", function() {
			this._handleValueChange();
			this._checkValidity();
		});
		this._propertyDefault.appendChild(this._createDisplayNode(this._defaultValue));
		if (this._descriptionMode == "table") {
			this._propertyDescription.appendChild(document.createTextNode(this._description));
			this._propertyDescription.className = "fadedText";
			this._propertyDescription.style.display = "";
		}
		this._show();
		this._checkValidity();
	}
});

})();